Further harden glibc malloc metadata against 1-byte overflows.
[glibc.git] / elf / tst-ldconfig-X.sh
blobe97ca89946b182f60858008d77805919aa2952f0
1 #!/bin/sh
2 # Test that ldconfig -X does not remove stale symbolic links.
3 # Copyright (C) 2000-2017 Free Software Foundation, Inc.
4 # This file is part of the GNU C Library.
6 # The GNU C Library is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU Lesser General Public
8 # License as published by the Free Software Foundation; either
9 # version 2.1 of the License, or (at your option) any later version.
11 # The GNU C Library is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14 # Lesser General Public License for more details.
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with the GNU C Library; if not, see
18 # <http://www.gnu.org/licenses/>.
20 set -ex
22 common_objpfx=$1
23 test_wrapper_env=$2
24 run_program_env=$3
26 testroot="${common_objpfx}elf/bug19610-test-directory"
27 cleanup () {
28 rm -rf "$testroot"
30 trap cleanup 0
32 rm -rf "$testroot"
33 mkdir -p $testroot/lib $testroot/etc
35 # Relative symbolic link target.
36 ln -s libdoesnotexist.so.1.1 $testroot/lib/libdoesnotexist.so.1
38 # Absolute symbolic link target.
39 ln -s $testroot/opt/sw/lib/libdoesnotexist2.so.1.1 $testroot/lib/
41 errors=0
42 check_files () {
43 for name in libdoesnotexist.so.1 libdoesnotexist2.so.1.1 ; do
44 path="$testroot/lib/$name"
45 if test ! -h $path ; then
46 echo "error: missing file: $path"
47 errors=1
49 done
52 check_files
54 ${test_wrapper_env} \
55 ${run_program_env} \
56 ${common_objpfx}elf/ldconfig -X -f /dev/null \
57 -C $testroot/etc/ld.so.cache \
58 $testroot/lib
60 check_files
62 exit $errors